<?php

$url1 = 'http://stepup.yahoo.co.jp/drill/answer.html?gi=03&co=23&di=23003&qn=1&ba=http%3A%2F%2Fstepup.yahoo.co.jp%2Fdrill%2Flist.html%3Fgi%3D03%26amp%3Bco%3D23%26amp%3Bdi%3D23003%26amp%3Bba%3Dhttp%253A%252F%252Fstepup.yahoo.co.jp%252Fdrill%252Fdrill.html%253Fgi%253D03%2526amp%253Bco%253D23%2526amp%253Bdi%253D23003';
//$url1 = 'http://stepup.yahoo.co.jp/drill/answer.html?gi=03&co=23&di=23007&qn=601&ba=http://stepup.yahoo.co.jp/drill/list.html%3Fgi%3D03%26amp;co%3D23%26amp;di%3D23007%26amp;ba%3Dhttp%253A%252F%252Fstepup.yahoo.co.jp%252Fdrill%252Fdrill.html%253Fgi%253D03%2526amp%253Bco%253D23%2526amp%253Bdi%253D23007%26amp;b%3D600';

echo "start\n";

$fp = fopen("result.csv", "w");
if ($fp == false) {
    die("failed to write file...");
}

$n = 1;
while (!empty($url1)) {
    $retry = 3;
    for ($i=0; $i<$retry; $i++) {
        $next_url = parse1($url1, $fp);
        if ($next_url === false) {
            break;
        }
        if (!empty($next_url)) {
            break;
        }
        echo " .\n";
    }
    if (empty($next_url)) {
        break;
    }
    $url1 = 'http://stepup.yahoo.co.jp' . $next_url;
    $n ++;
    if ($n > 1120) {
        break;
    }
}
fclose($fp);
printf("finish.\n");

function parse1($url, $fp)
{
    $v = file_get_contents($url);
//    $v = mb_convert_encoding($v, 'UTF-8', 'EUC-JP');
    $v = preg_replace("/(\r\n|\r|\n)/", "", $v);

    $r = array();
    if (!preg_match('|<div id="mondai-number">.*?<dd>(.*?)</dd>|', $v, $matches)) {
        echo " x1\n";
        return null;
    }
    $r['title'] = $matches[1];

    if (!preg_match('|<!--/div#mondai-title--><p id="commentary-txt">.*?<br>(.*?)<br>(.*?)</p>|', $v, $matches)) {
        echo " x2\n";
        return null;
    }

    $r['e1'] = $matches[1];
    $r['es'] = $matches[2];

    if (!preg_match('|<!--/div.sincyoku-title-->.*?<p id="commentary-txt">.*?(.*?)<br>.*?(.*?)?<br>|', $v, $matches)) {
        if (!preg_match('|<!--/div.sincyoku-title-->.*?<p id="commentary-txt">(.*?)<br>.*?(.*?)?<br>|', $v, $matches)) {
            echo " (no ex.)\n";
        }
    }
    $r['j1'] = $matches[1];
    $r['js'] = $matches[2];

	printf("%s,%s\n", $r['title'], $r['e1']);
	
	foreach ($r as $key => $val) {
	    $val = mb_convert_encoding($val, 'Shift-JIS', 'EUC-JP');
	    $r[$key] = $val;
	}

    fwrite($fp, '"' . $r['title'] . '"' . ",");
    fwrite($fp, '"' . $r['e1'] . '"' . ",");
    fwrite($fp, '"' . $r['es'] . '"' . ",");
    fwrite($fp, '"' . $r['j1'] . '"' . ",");
    fwrite($fp, '"' . $r['js'] . '"' . "\r\n");
//    flush();

    if (!preg_match('|<a href="([^"]*?)" title="">|', $v, $matches)) {
        echo " not found next question.\n";
        return false;
    }

    return $matches[1];
}

?>
